import { addSchema } from "@kubernetes-models/apimachinery/_schemas/IoK8sApimachineryPkgApisMetaV1ObjectMeta";
import { Model, setSchema, createTypeMetaGuard } from "@kubernetes-models/base";
import { register } from "@kubernetes-models/validate";
const schemaId = "internal.packaging.carvel.dev.v1alpha1.InternalPackage";
const schema = {
    "type": "object",
    "properties": {
        "apiVersion": {
            "type": "string",
            "enum": [
                "internal.packaging.carvel.dev/v1alpha1"
            ]
        },
        "kind": {
            "type": "string",
            "enum": [
                "InternalPackage"
            ]
        },
        "metadata": {
            "oneOf": [
                {
                    "$ref": "io.k8s.apimachinery.pkg.apis.meta.v1.ObjectMeta#"
                },
                {
                    "type": "null"
                }
            ]
        },
        "spec": {
            "properties": {
                "capacityRequirementsDescription": {
                    "type": "string",
                    "nullable": true
                },
                "includedSoftware": {
                    "items": {
                        "properties": {
                            "displayName": {
                                "type": "string",
                                "nullable": true
                            },
                            "version": {
                                "type": "string",
                                "nullable": true
                            }
                        },
                        "type": "object"
                    },
                    "type": "array",
                    "nullable": true
                },
                "kappControllerVersionSelection": {
                    "properties": {
                        "constraints": {
                            "type": "string",
                            "nullable": true
                        }
                    },
                    "type": "object",
                    "nullable": true
                },
                "kubernetesVersionSelection": {
                    "properties": {
                        "constraints": {
                            "type": "string",
                            "nullable": true
                        }
                    },
                    "type": "object",
                    "nullable": true
                },
                "licenses": {
                    "items": {
                        "type": "string"
                    },
                    "type": "array",
                    "nullable": true
                },
                "refName": {
                    "type": "string",
                    "nullable": true
                },
                "releaseNotes": {
                    "type": "string",
                    "nullable": true
                },
                "releasedAt": {
                    "format": "date-time",
                    "nullable": true,
                    "type": "string"
                },
                "template": {
                    "properties": {
                        "spec": {
                            "properties": {
                                "canceled": {
                                    "type": "boolean",
                                    "nullable": true
                                },
                                "cluster": {
                                    "properties": {
                                        "kubeconfigSecretRef": {
                                            "properties": {
                                                "key": {
                                                    "type": "string",
                                                    "nullable": true
                                                },
                                                "name": {
                                                    "type": "string",
                                                    "nullable": true
                                                }
                                            },
                                            "type": "object",
                                            "nullable": true
                                        },
                                        "namespace": {
                                            "type": "string",
                                            "nullable": true
                                        }
                                    },
                                    "type": "object",
                                    "nullable": true
                                },
                                "deploy": {
                                    "items": {
                                        "properties": {
                                            "kapp": {
                                                "properties": {
                                                    "delete": {
                                                        "properties": {
                                                            "rawOptions": {
                                                                "items": {
                                                                    "type": "string"
                                                                },
                                                                "type": "array",
                                                                "nullable": true
                                                            }
                                                        },
                                                        "type": "object",
                                                        "nullable": true
                                                    },
                                                    "inspect": {
                                                        "properties": {
                                                            "rawOptions": {
                                                                "items": {
                                                                    "type": "string"
                                                                },
                                                                "type": "array",
                                                                "nullable": true
                                                            }
                                                        },
                                                        "type": "object",
                                                        "nullable": true
                                                    },
                                                    "intoNs": {
                                                        "type": "string",
                                                        "nullable": true
                                                    },
                                                    "mapNs": {
                                                        "items": {
                                                            "type": "string"
                                                        },
                                                        "type": "array",
                                                        "nullable": true
                                                    },
                                                    "rawOptions": {
                                                        "items": {
                                                            "type": "string"
                                                        },
                                                        "type": "array",
                                                        "nullable": true
                                                    }
                                                },
                                                "type": "object",
                                                "nullable": true
                                            }
                                        },
                                        "type": "object"
                                    },
                                    "type": "array",
                                    "nullable": true
                                },
                                "fetch": {
                                    "items": {
                                        "properties": {
                                            "git": {
                                                "properties": {
                                                    "lfsSkipSmudge": {
                                                        "type": "boolean",
                                                        "nullable": true
                                                    },
                                                    "ref": {
                                                        "type": "string",
                                                        "nullable": true
                                                    },
                                                    "refSelection": {
                                                        "properties": {
                                                            "semver": {
                                                                "properties": {
                                                                    "constraints": {
                                                                        "type": "string",
                                                                        "nullable": true
                                                                    },
                                                                    "prereleases": {
                                                                        "properties": {
                                                                            "identifiers": {
                                                                                "items": {
                                                                                    "type": "string"
                                                                                },
                                                                                "type": "array",
                                                                                "nullable": true
                                                                            }
                                                                        },
                                                                        "type": "object",
                                                                        "nullable": true
                                                                    }
                                                                },
                                                                "type": "object",
                                                                "nullable": true
                                                            }
                                                        },
                                                        "type": "object",
                                                        "nullable": true
                                                    },
                                                    "secretRef": {
                                                        "properties": {
                                                            "name": {
                                                                "type": "string",
                                                                "nullable": true
                                                            }
                                                        },
                                                        "type": "object",
                                                        "nullable": true
                                                    },
                                                    "subPath": {
                                                        "type": "string",
                                                        "nullable": true
                                                    },
                                                    "url": {
                                                        "type": "string",
                                                        "nullable": true
                                                    }
                                                },
                                                "type": "object",
                                                "nullable": true
                                            },
                                            "helmChart": {
                                                "properties": {
                                                    "name": {
                                                        "type": "string",
                                                        "nullable": true
                                                    },
                                                    "repository": {
                                                        "properties": {
                                                            "secretRef": {
                                                                "properties": {
                                                                    "name": {
                                                                        "type": "string",
                                                                        "nullable": true
                                                                    }
                                                                },
                                                                "type": "object",
                                                                "nullable": true
                                                            },
                                                            "url": {
                                                                "type": "string",
                                                                "nullable": true
                                                            }
                                                        },
                                                        "type": "object",
                                                        "nullable": true
                                                    },
                                                    "version": {
                                                        "type": "string",
                                                        "nullable": true
                                                    }
                                                },
                                                "type": "object",
                                                "nullable": true
                                            },
                                            "http": {
                                                "properties": {
                                                    "secretRef": {
                                                        "properties": {
                                                            "name": {
                                                                "type": "string",
                                                                "nullable": true
                                                            }
                                                        },
                                                        "type": "object",
                                                        "nullable": true
                                                    },
                                                    "sha256": {
                                                        "type": "string",
                                                        "nullable": true
                                                    },
                                                    "subPath": {
                                                        "type": "string",
                                                        "nullable": true
                                                    },
                                                    "url": {
                                                        "type": "string",
                                                        "nullable": true
                                                    }
                                                },
                                                "type": "object",
                                                "nullable": true
                                            },
                                            "image": {
                                                "properties": {
                                                    "secretRef": {
                                                        "properties": {
                                                            "name": {
                                                                "type": "string",
                                                                "nullable": true
                                                            }
                                                        },
                                                        "type": "object",
                                                        "nullable": true
                                                    },
                                                    "subPath": {
                                                        "type": "string",
                                                        "nullable": true
                                                    },
                                                    "tagSelection": {
                                                        "properties": {
                                                            "semver": {
                                                                "properties": {
                                                                    "constraints": {
                                                                        "type": "string",
                                                                        "nullable": true
                                                                    },
                                                                    "prereleases": {
                                                                        "properties": {
                                                                            "identifiers": {
                                                                                "items": {
                                                                                    "type": "string"
                                                                                },
                                                                                "type": "array",
                                                                                "nullable": true
                                                                            }
                                                                        },
                                                                        "type": "object",
                                                                        "nullable": true
                                                                    }
                                                                },
                                                                "type": "object",
                                                                "nullable": true
                                                            }
                                                        },
                                                        "type": "object",
                                                        "nullable": true
                                                    },
                                                    "url": {
                                                        "type": "string",
                                                        "nullable": true
                                                    }
                                                },
                                                "type": "object",
                                                "nullable": true
                                            },
                                            "imgpkgBundle": {
                                                "properties": {
                                                    "image": {
                                                        "type": "string",
                                                        "nullable": true
                                                    },
                                                    "secretRef": {
                                                        "properties": {
                                                            "name": {
                                                                "type": "string",
                                                                "nullable": true
                                                            }
                                                        },
                                                        "type": "object",
                                                        "nullable": true
                                                    },
                                                    "tagSelection": {
                                                        "properties": {
                                                            "semver": {
                                                                "properties": {
                                                                    "constraints": {
                                                                        "type": "string",
                                                                        "nullable": true
                                                                    },
                                                                    "prereleases": {
                                                                        "properties": {
                                                                            "identifiers": {
                                                                                "items": {
                                                                                    "type": "string"
                                                                                },
                                                                                "type": "array",
                                                                                "nullable": true
                                                                            }
                                                                        },
                                                                        "type": "object",
                                                                        "nullable": true
                                                                    }
                                                                },
                                                                "type": "object",
                                                                "nullable": true
                                                            }
                                                        },
                                                        "type": "object",
                                                        "nullable": true
                                                    }
                                                },
                                                "type": "object",
                                                "nullable": true
                                            },
                                            "inline": {
                                                "properties": {
                                                    "paths": {
                                                        "additionalProperties": {
                                                            "type": "string"
                                                        },
                                                        "type": "object",
                                                        "properties": {},
                                                        "nullable": true
                                                    },
                                                    "pathsFrom": {
                                                        "items": {
                                                            "properties": {
                                                                "configMapRef": {
                                                                    "properties": {
                                                                        "directoryPath": {
                                                                            "type": "string",
                                                                            "nullable": true
                                                                        },
                                                                        "name": {
                                                                            "type": "string",
                                                                            "nullable": true
                                                                        }
                                                                    },
                                                                    "type": "object",
                                                                    "nullable": true
                                                                },
                                                                "secretRef": {
                                                                    "properties": {
                                                                        "directoryPath": {
                                                                            "type": "string",
                                                                            "nullable": true
                                                                        },
                                                                        "name": {
                                                                            "type": "string",
                                                                            "nullable": true
                                                                        }
                                                                    },
                                                                    "type": "object",
                                                                    "nullable": true
                                                                }
                                                            },
                                                            "type": "object"
                                                        },
                                                        "type": "array",
                                                        "nullable": true
                                                    }
                                                },
                                                "type": "object",
                                                "nullable": true
                                            },
                                            "path": {
                                                "type": "string",
                                                "nullable": true
                                            }
                                        },
                                        "type": "object"
                                    },
                                    "type": "array",
                                    "nullable": true
                                },
                                "noopDelete": {
                                    "type": "boolean",
                                    "nullable": true
                                },
                                "paused": {
                                    "type": "boolean",
                                    "nullable": true
                                },
                                "serviceAccountName": {
                                    "type": "string",
                                    "nullable": true
                                },
                                "syncPeriod": {
                                    "type": "string",
                                    "nullable": true
                                },
                                "template": {
                                    "items": {
                                        "properties": {
                                            "cue": {
                                                "properties": {
                                                    "inputExpression": {
                                                        "type": "string",
                                                        "nullable": true
                                                    },
                                                    "outputExpression": {
                                                        "type": "string",
                                                        "nullable": true
                                                    },
                                                    "paths": {
                                                        "items": {
                                                            "type": "string"
                                                        },
                                                        "type": "array",
                                                        "nullable": true
                                                    },
                                                    "valuesFrom": {
                                                        "items": {
                                                            "properties": {
                                                                "configMapRef": {
                                                                    "properties": {
                                                                        "name": {
                                                                            "type": "string",
                                                                            "nullable": true
                                                                        }
                                                                    },
                                                                    "type": "object",
                                                                    "nullable": true
                                                                },
                                                                "downwardAPI": {
                                                                    "properties": {
                                                                        "items": {
                                                                            "items": {
                                                                                "properties": {
                                                                                    "fieldPath": {
                                                                                        "type": "string",
                                                                                        "nullable": true
                                                                                    },
                                                                                    "kappControllerVersion": {
                                                                                        "properties": {
                                                                                            "version": {
                                                                                                "type": "string",
                                                                                                "nullable": true
                                                                                            }
                                                                                        },
                                                                                        "type": "object",
                                                                                        "nullable": true
                                                                                    },
                                                                                    "kubernetesAPIs": {
                                                                                        "properties": {
                                                                                            "groupVersions": {
                                                                                                "items": {
                                                                                                    "type": "string"
                                                                                                },
                                                                                                "type": "array",
                                                                                                "nullable": true
                                                                                            }
                                                                                        },
                                                                                        "type": "object",
                                                                                        "nullable": true
                                                                                    },
                                                                                    "kubernetesVersion": {
                                                                                        "properties": {
                                                                                            "version": {
                                                                                                "type": "string",
                                                                                                "nullable": true
                                                                                            }
                                                                                        },
                                                                                        "type": "object",
                                                                                        "nullable": true
                                                                                    },
                                                                                    "name": {
                                                                                        "type": "string",
                                                                                        "nullable": true
                                                                                    }
                                                                                },
                                                                                "type": "object"
                                                                            },
                                                                            "type": "array",
                                                                            "nullable": true
                                                                        }
                                                                    },
                                                                    "type": "object",
                                                                    "nullable": true
                                                                },
                                                                "path": {
                                                                    "type": "string",
                                                                    "nullable": true
                                                                },
                                                                "secretRef": {
                                                                    "properties": {
                                                                        "name": {
                                                                            "type": "string",
                                                                            "nullable": true
                                                                        }
                                                                    },
                                                                    "type": "object",
                                                                    "nullable": true
                                                                }
                                                            },
                                                            "type": "object"
                                                        },
                                                        "type": "array",
                                                        "nullable": true
                                                    }
                                                },
                                                "type": "object",
                                                "nullable": true
                                            },
                                            "helmTemplate": {
                                                "properties": {
                                                    "kubernetesAPIs": {
                                                        "properties": {
                                                            "groupVersions": {
                                                                "items": {
                                                                    "type": "string"
                                                                },
                                                                "type": "array",
                                                                "nullable": true
                                                            }
                                                        },
                                                        "type": "object",
                                                        "nullable": true
                                                    },
                                                    "kubernetesVersion": {
                                                        "properties": {
                                                            "version": {
                                                                "type": "string",
                                                                "nullable": true
                                                            }
                                                        },
                                                        "type": "object",
                                                        "nullable": true
                                                    },
                                                    "name": {
                                                        "type": "string",
                                                        "nullable": true
                                                    },
                                                    "namespace": {
                                                        "type": "string",
                                                        "nullable": true
                                                    },
                                                    "path": {
                                                        "type": "string",
                                                        "nullable": true
                                                    },
                                                    "valuesFrom": {
                                                        "items": {
                                                            "properties": {
                                                                "configMapRef": {
                                                                    "properties": {
                                                                        "name": {
                                                                            "type": "string",
                                                                            "nullable": true
                                                                        }
                                                                    },
                                                                    "type": "object",
                                                                    "nullable": true
                                                                },
                                                                "downwardAPI": {
                                                                    "properties": {
                                                                        "items": {
                                                                            "items": {
                                                                                "properties": {
                                                                                    "fieldPath": {
                                                                                        "type": "string",
                                                                                        "nullable": true
                                                                                    },
                                                                                    "kappControllerVersion": {
                                                                                        "properties": {
                                                                                            "version": {
                                                                                                "type": "string",
                                                                                                "nullable": true
                                                                                            }
                                                                                        },
                                                                                        "type": "object",
                                                                                        "nullable": true
                                                                                    },
                                                                                    "kubernetesAPIs": {
                                                                                        "properties": {
                                                                                            "groupVersions": {
                                                                                                "items": {
                                                                                                    "type": "string"
                                                                                                },
                                                                                                "type": "array",
                                                                                                "nullable": true
                                                                                            }
                                                                                        },
                                                                                        "type": "object",
                                                                                        "nullable": true
                                                                                    },
                                                                                    "kubernetesVersion": {
                                                                                        "properties": {
                                                                                            "version": {
                                                                                                "type": "string",
                                                                                                "nullable": true
                                                                                            }
                                                                                        },
                                                                                        "type": "object",
                                                                                        "nullable": true
                                                                                    },
                                                                                    "name": {
                                                                                        "type": "string",
                                                                                        "nullable": true
                                                                                    }
                                                                                },
                                                                                "type": "object"
                                                                            },
                                                                            "type": "array",
                                                                            "nullable": true
                                                                        }
                                                                    },
                                                                    "type": "object",
                                                                    "nullable": true
                                                                },
                                                                "path": {
                                                                    "type": "string",
                                                                    "nullable": true
                                                                },
                                                                "secretRef": {
                                                                    "properties": {
                                                                        "name": {
                                                                            "type": "string",
                                                                            "nullable": true
                                                                        }
                                                                    },
                                                                    "type": "object",
                                                                    "nullable": true
                                                                }
                                                            },
                                                            "type": "object"
                                                        },
                                                        "type": "array",
                                                        "nullable": true
                                                    }
                                                },
                                                "type": "object",
                                                "nullable": true
                                            },
                                            "jsonnet": {
                                                "type": "object",
                                                "properties": {},
                                                "nullable": true
                                            },
                                            "kbld": {
                                                "properties": {
                                                    "paths": {
                                                        "items": {
                                                            "type": "string"
                                                        },
                                                        "type": "array",
                                                        "nullable": true
                                                    }
                                                },
                                                "type": "object",
                                                "nullable": true
                                            },
                                            "kustomize": {
                                                "type": "object",
                                                "properties": {},
                                                "nullable": true
                                            },
                                            "sops": {
                                                "properties": {
                                                    "age": {
                                                        "properties": {
                                                            "privateKeysSecretRef": {
                                                                "properties": {
                                                                    "name": {
                                                                        "type": "string",
                                                                        "nullable": true
                                                                    }
                                                                },
                                                                "type": "object",
                                                                "nullable": true
                                                            }
                                                        },
                                                        "type": "object",
                                                        "nullable": true
                                                    },
                                                    "paths": {
                                                        "items": {
                                                            "type": "string"
                                                        },
                                                        "type": "array",
                                                        "nullable": true
                                                    },
                                                    "pgp": {
                                                        "properties": {
                                                            "privateKeysSecretRef": {
                                                                "properties": {
                                                                    "name": {
                                                                        "type": "string",
                                                                        "nullable": true
                                                                    }
                                                                },
                                                                "type": "object",
                                                                "nullable": true
                                                            }
                                                        },
                                                        "type": "object",
                                                        "nullable": true
                                                    }
                                                },
                                                "type": "object",
                                                "nullable": true
                                            },
                                            "ytt": {
                                                "properties": {
                                                    "fileMarks": {
                                                        "items": {
                                                            "type": "string"
                                                        },
                                                        "type": "array",
                                                        "nullable": true
                                                    },
                                                    "ignoreUnknownComments": {
                                                        "type": "boolean",
                                                        "nullable": true
                                                    },
                                                    "inline": {
                                                        "properties": {
                                                            "paths": {
                                                                "additionalProperties": {
                                                                    "type": "string"
                                                                },
                                                                "type": "object",
                                                                "properties": {},
                                                                "nullable": true
                                                            },
                                                            "pathsFrom": {
                                                                "items": {
                                                                    "properties": {
                                                                        "configMapRef": {
                                                                            "properties": {
                                                                                "directoryPath": {
                                                                                    "type": "string",
                                                                                    "nullable": true
                                                                                },
                                                                                "name": {
                                                                                    "type": "string",
                                                                                    "nullable": true
                                                                                }
                                                                            },
                                                                            "type": "object",
                                                                            "nullable": true
                                                                        },
                                                                        "secretRef": {
                                                                            "properties": {
                                                                                "directoryPath": {
                                                                                    "type": "string",
                                                                                    "nullable": true
                                                                                },
                                                                                "name": {
                                                                                    "type": "string",
                                                                                    "nullable": true
                                                                                }
                                                                            },
                                                                            "type": "object",
                                                                            "nullable": true
                                                                        }
                                                                    },
                                                                    "type": "object"
                                                                },
                                                                "type": "array",
                                                                "nullable": true
                                                            }
                                                        },
                                                        "type": "object",
                                                        "nullable": true
                                                    },
                                                    "paths": {
                                                        "items": {
                                                            "type": "string"
                                                        },
                                                        "type": "array",
                                                        "nullable": true
                                                    },
                                                    "strict": {
                                                        "type": "boolean",
                                                        "nullable": true
                                                    },
                                                    "valuesFrom": {
                                                        "items": {
                                                            "properties": {
                                                                "configMapRef": {
                                                                    "properties": {
                                                                        "name": {
                                                                            "type": "string",
                                                                            "nullable": true
                                                                        }
                                                                    },
                                                                    "type": "object",
                                                                    "nullable": true
                                                                },
                                                                "downwardAPI": {
                                                                    "properties": {
                                                                        "items": {
                                                                            "items": {
                                                                                "properties": {
                                                                                    "fieldPath": {
                                                                                        "type": "string",
                                                                                        "nullable": true
                                                                                    },
                                                                                    "kappControllerVersion": {
                                                                                        "properties": {
                                                                                            "version": {
                                                                                                "type": "string",
                                                                                                "nullable": true
                                                                                            }
                                                                                        },
                                                                                        "type": "object",
                                                                                        "nullable": true
                                                                                    },
                                                                                    "kubernetesAPIs": {
                                                                                        "properties": {
                                                                                            "groupVersions": {
                                                                                                "items": {
                                                                                                    "type": "string"
                                                                                                },
                                                                                                "type": "array",
                                                                                                "nullable": true
                                                                                            }
                                                                                        },
                                                                                        "type": "object",
                                                                                        "nullable": true
                                                                                    },
                                                                                    "kubernetesVersion": {
                                                                                        "properties": {
                                                                                            "version": {
                                                                                                "type": "string",
                                                                                                "nullable": true
                                                                                            }
                                                                                        },
                                                                                        "type": "object",
                                                                                        "nullable": true
                                                                                    },
                                                                                    "name": {
                                                                                        "type": "string",
                                                                                        "nullable": true
                                                                                    }
                                                                                },
                                                                                "type": "object"
                                                                            },
                                                                            "type": "array",
                                                                            "nullable": true
                                                                        }
                                                                    },
                                                                    "type": "object",
                                                                    "nullable": true
                                                                },
                                                                "path": {
                                                                    "type": "string",
                                                                    "nullable": true
                                                                },
                                                                "secretRef": {
                                                                    "properties": {
                                                                        "name": {
                                                                            "type": "string",
                                                                            "nullable": true
                                                                        }
                                                                    },
                                                                    "type": "object",
                                                                    "nullable": true
                                                                }
                                                            },
                                                            "type": "object"
                                                        },
                                                        "type": "array",
                                                        "nullable": true
                                                    }
                                                },
                                                "type": "object",
                                                "nullable": true
                                            }
                                        },
                                        "type": "object"
                                    },
                                    "type": "array",
                                    "nullable": true
                                }
                            },
                            "type": "object"
                        }
                    },
                    "required": [
                        "spec"
                    ],
                    "type": "object",
                    "nullable": true
                },
                "valuesSchema": {
                    "properties": {
                        "openAPIv3": {
                            "nullable": true,
                            "type": "object",
                            "properties": {}
                        }
                    },
                    "type": "object",
                    "nullable": true
                },
                "version": {
                    "type": "string",
                    "nullable": true
                }
            },
            "type": "object"
        }
    },
    "required": [
        "spec",
        "apiVersion",
        "kind"
    ]
};
export class InternalPackage extends Model {
    constructor(data) {
        super({
            apiVersion: InternalPackage.apiVersion,
            kind: InternalPackage.kind,
            ...data
        });
    }
}
InternalPackage.apiVersion = "internal.packaging.carvel.dev/v1alpha1";
InternalPackage.kind = "InternalPackage";
InternalPackage.is = createTypeMetaGuard(InternalPackage);
setSchema(InternalPackage, schemaId, () => {
    addSchema();
    register(schemaId, schema);
});
