import { addSchema } from "@kubernetes-models/apimachinery/_schemas/IoK8sApimachineryPkgApisMetaV1ObjectMeta";
import { Model, setSchema, createTypeMetaGuard } from "@kubernetes-models/base";
import { register } from "@kubernetes-models/validate";
const schemaId = "packaging.carvel.dev.v1alpha1.PackageRepository";
const schema = {
    "type": "object",
    "properties": {
        "apiVersion": {
            "type": "string",
            "enum": [
                "packaging.carvel.dev/v1alpha1"
            ]
        },
        "kind": {
            "type": "string",
            "enum": [
                "PackageRepository"
            ]
        },
        "metadata": {
            "oneOf": [
                {
                    "$ref": "io.k8s.apimachinery.pkg.apis.meta.v1.ObjectMeta#"
                },
                {
                    "type": "null"
                }
            ]
        },
        "spec": {
            "properties": {
                "fetch": {
                    "properties": {
                        "git": {
                            "properties": {
                                "lfsSkipSmudge": {
                                    "type": "boolean",
                                    "nullable": true
                                },
                                "ref": {
                                    "type": "string",
                                    "nullable": true
                                },
                                "refSelection": {
                                    "properties": {
                                        "semver": {
                                            "properties": {
                                                "constraints": {
                                                    "type": "string",
                                                    "nullable": true
                                                },
                                                "prereleases": {
                                                    "properties": {
                                                        "identifiers": {
                                                            "items": {
                                                                "type": "string"
                                                            },
                                                            "type": "array",
                                                            "nullable": true
                                                        }
                                                    },
                                                    "type": "object",
                                                    "nullable": true
                                                }
                                            },
                                            "type": "object",
                                            "nullable": true
                                        }
                                    },
                                    "type": "object",
                                    "nullable": true
                                },
                                "secretRef": {
                                    "properties": {
                                        "name": {
                                            "type": "string",
                                            "nullable": true
                                        }
                                    },
                                    "type": "object",
                                    "nullable": true
                                },
                                "subPath": {
                                    "type": "string",
                                    "nullable": true
                                },
                                "url": {
                                    "type": "string",
                                    "nullable": true
                                }
                            },
                            "type": "object",
                            "nullable": true
                        },
                        "http": {
                            "properties": {
                                "secretRef": {
                                    "properties": {
                                        "name": {
                                            "type": "string",
                                            "nullable": true
                                        }
                                    },
                                    "type": "object",
                                    "nullable": true
                                },
                                "sha256": {
                                    "type": "string",
                                    "nullable": true
                                },
                                "subPath": {
                                    "type": "string",
                                    "nullable": true
                                },
                                "url": {
                                    "type": "string",
                                    "nullable": true
                                }
                            },
                            "type": "object",
                            "nullable": true
                        },
                        "image": {
                            "properties": {
                                "secretRef": {
                                    "properties": {
                                        "name": {
                                            "type": "string",
                                            "nullable": true
                                        }
                                    },
                                    "type": "object",
                                    "nullable": true
                                },
                                "subPath": {
                                    "type": "string",
                                    "nullable": true
                                },
                                "tagSelection": {
                                    "properties": {
                                        "semver": {
                                            "properties": {
                                                "constraints": {
                                                    "type": "string",
                                                    "nullable": true
                                                },
                                                "prereleases": {
                                                    "properties": {
                                                        "identifiers": {
                                                            "items": {
                                                                "type": "string"
                                                            },
                                                            "type": "array",
                                                            "nullable": true
                                                        }
                                                    },
                                                    "type": "object",
                                                    "nullable": true
                                                }
                                            },
                                            "type": "object",
                                            "nullable": true
                                        }
                                    },
                                    "type": "object",
                                    "nullable": true
                                },
                                "url": {
                                    "type": "string",
                                    "nullable": true
                                }
                            },
                            "type": "object",
                            "nullable": true
                        },
                        "imgpkgBundle": {
                            "properties": {
                                "image": {
                                    "type": "string",
                                    "nullable": true
                                },
                                "secretRef": {
                                    "properties": {
                                        "name": {
                                            "type": "string",
                                            "nullable": true
                                        }
                                    },
                                    "type": "object",
                                    "nullable": true
                                },
                                "tagSelection": {
                                    "properties": {
                                        "semver": {
                                            "properties": {
                                                "constraints": {
                                                    "type": "string",
                                                    "nullable": true
                                                },
                                                "prereleases": {
                                                    "properties": {
                                                        "identifiers": {
                                                            "items": {
                                                                "type": "string"
                                                            },
                                                            "type": "array",
                                                            "nullable": true
                                                        }
                                                    },
                                                    "type": "object",
                                                    "nullable": true
                                                }
                                            },
                                            "type": "object",
                                            "nullable": true
                                        }
                                    },
                                    "type": "object",
                                    "nullable": true
                                }
                            },
                            "type": "object",
                            "nullable": true
                        },
                        "inline": {
                            "properties": {
                                "paths": {
                                    "additionalProperties": {
                                        "type": "string"
                                    },
                                    "type": "object",
                                    "properties": {},
                                    "nullable": true
                                },
                                "pathsFrom": {
                                    "items": {
                                        "properties": {
                                            "configMapRef": {
                                                "properties": {
                                                    "directoryPath": {
                                                        "type": "string",
                                                        "nullable": true
                                                    },
                                                    "name": {
                                                        "type": "string",
                                                        "nullable": true
                                                    }
                                                },
                                                "type": "object",
                                                "nullable": true
                                            },
                                            "secretRef": {
                                                "properties": {
                                                    "directoryPath": {
                                                        "type": "string",
                                                        "nullable": true
                                                    },
                                                    "name": {
                                                        "type": "string",
                                                        "nullable": true
                                                    }
                                                },
                                                "type": "object",
                                                "nullable": true
                                            }
                                        },
                                        "type": "object"
                                    },
                                    "type": "array",
                                    "nullable": true
                                }
                            },
                            "type": "object",
                            "nullable": true
                        }
                    },
                    "type": "object"
                },
                "paused": {
                    "type": "boolean",
                    "nullable": true
                },
                "syncPeriod": {
                    "type": "string",
                    "nullable": true
                }
            },
            "required": [
                "fetch"
            ],
            "type": "object"
        },
        "status": {
            "properties": {
                "conditions": {
                    "items": {
                        "properties": {
                            "message": {
                                "type": "string",
                                "nullable": true
                            },
                            "reason": {
                                "type": "string",
                                "nullable": true
                            },
                            "status": {
                                "type": "string"
                            },
                            "type": {
                                "type": "string"
                            }
                        },
                        "required": [
                            "status",
                            "type"
                        ],
                        "type": "object"
                    },
                    "type": "array",
                    "nullable": true
                },
                "consecutiveReconcileFailures": {
                    "type": "integer",
                    "nullable": true
                },
                "consecutiveReconcileSuccesses": {
                    "type": "integer",
                    "nullable": true
                },
                "deploy": {
                    "properties": {
                        "error": {
                            "type": "string",
                            "nullable": true
                        },
                        "exitCode": {
                            "type": "integer",
                            "nullable": true
                        },
                        "finished": {
                            "type": "boolean",
                            "nullable": true
                        },
                        "kapp": {
                            "properties": {
                                "associatedResources": {
                                    "properties": {
                                        "groupKinds": {
                                            "items": {
                                                "properties": {
                                                    "group": {
                                                        "type": "string"
                                                    },
                                                    "kind": {
                                                        "type": "string"
                                                    }
                                                },
                                                "required": [
                                                    "group",
                                                    "kind"
                                                ],
                                                "type": "object"
                                            },
                                            "type": "array",
                                            "nullable": true
                                        },
                                        "label": {
                                            "type": "string",
                                            "nullable": true
                                        },
                                        "namespaces": {
                                            "items": {
                                                "type": "string"
                                            },
                                            "type": "array",
                                            "nullable": true
                                        }
                                    },
                                    "type": "object",
                                    "nullable": true
                                }
                            },
                            "type": "object",
                            "nullable": true
                        },
                        "startedAt": {
                            "format": "date-time",
                            "type": "string",
                            "nullable": true
                        },
                        "stderr": {
                            "type": "string",
                            "nullable": true
                        },
                        "stdout": {
                            "type": "string",
                            "nullable": true
                        },
                        "updatedAt": {
                            "format": "date-time",
                            "type": "string",
                            "nullable": true
                        }
                    },
                    "type": "object",
                    "nullable": true
                },
                "fetch": {
                    "properties": {
                        "error": {
                            "type": "string",
                            "nullable": true
                        },
                        "exitCode": {
                            "type": "integer",
                            "nullable": true
                        },
                        "startedAt": {
                            "format": "date-time",
                            "type": "string",
                            "nullable": true
                        },
                        "stderr": {
                            "type": "string",
                            "nullable": true
                        },
                        "stdout": {
                            "type": "string",
                            "nullable": true
                        },
                        "updatedAt": {
                            "format": "date-time",
                            "type": "string",
                            "nullable": true
                        }
                    },
                    "type": "object",
                    "nullable": true
                },
                "friendlyDescription": {
                    "type": "string",
                    "nullable": true
                },
                "observedGeneration": {
                    "format": "int64",
                    "type": "integer",
                    "nullable": true
                },
                "template": {
                    "properties": {
                        "error": {
                            "type": "string",
                            "nullable": true
                        },
                        "exitCode": {
                            "type": "integer",
                            "nullable": true
                        },
                        "stderr": {
                            "type": "string",
                            "nullable": true
                        },
                        "updatedAt": {
                            "format": "date-time",
                            "type": "string",
                            "nullable": true
                        }
                    },
                    "type": "object",
                    "nullable": true
                },
                "usefulErrorMessage": {
                    "type": "string",
                    "nullable": true
                }
            },
            "type": "object",
            "nullable": true
        }
    },
    "required": [
        "spec",
        "apiVersion",
        "kind"
    ]
};
/**
 * A package repository is a collection of packages and their metadata. Similar to a maven repository or a rpm repository, adding a package repository to a cluster gives users of that cluster the ability to install any of the packages from that repository.
 */
export class PackageRepository extends Model {
    constructor(data) {
        super({
            apiVersion: PackageRepository.apiVersion,
            kind: PackageRepository.kind,
            ...data
        });
    }
}
PackageRepository.apiVersion = "packaging.carvel.dev/v1alpha1";
PackageRepository.kind = "PackageRepository";
PackageRepository.is = createTypeMetaGuard(PackageRepository);
setSchema(PackageRepository, schemaId, () => {
    addSchema();
    register(schemaId, schema);
});
